c*****************************************************************
                        function cross(x)
c*****************************************************************
c
        implicit complex*16 (a)
        implicit real*8    (b-h,m,o-z)
        implicit integer (i-l,n)
        real*8 gal(2),inprod
        real*8 k0(0:3),p0(0:3),q0(0:3),pp0(0:3),pm0(0:3),kPp(0:3)
        real*8 k1(0:3),p1(0:3),q1(0:3),pp1(0:3),pm1(0:3)
        real*8 pp2(0:3),pm2(0:3),ppm(0:3)
        real*8 x(25)
        real*8 lnmir,jcob1,jcob3
	real*8 ATACC,ACC1,ACC2
c
        common /kine1/ pi,mimin,mimax,mir,lnmir,e0,pol,me,me2
        common /kine2/ s,rts,ek1,ep1,fac,fac2,sw2,gal,del1,del2
        common /momnt/ k0,k1,p0,p1
	common /cutof/ qmin,paircut,polmin,polmax,opnmin,opnmax
	COMMON /BASE3/ SI,SI2,SWGT,SCHI,SCALLS,ATACC,NSU,IT,WGT
	COMMON /BASE2/ ACC1,ACC2,ITMX1,ITMX2
	common /dump/  ievent,idumpflag,ievmax
c
	ielec = 3
	iposi = 2
c-----------------------------------------------------------------
c            Transformation from x to phisical variable
c-----------------------------------------------------------------
        exx    = exp(x(1))
c
        costht = ((1.0+del1)*exx-(1.0+del2))/(1.0+exx)
c	costht = x(1)
        phi    = x(2)
c	mi     = x(3)
        mi     = mimin*mir**x(3)
        cosalp = x(4)
        bet    = x(5)
        if(costht.gt.1.D0.or.costht.lt.-1.D0) then
           cross=0.D0
           return
        endif
        if(mi.gt.mimax.or.mi.lt.mimin) then
           cross=0.D0
           return
        endif
c
        ih = x(6)
	ie = ih/(2*2*2*2)
	ih = ih-ie*2*2*2*2
        ia = ih/(2*2*2)
        ih = ih-ia*2*2*2
        ib = ih/(2*2)
        ih = ih-ib*2*2
        ic = ih/2
        id = ih-ic*2
c
	nk  = ie*2-1
        np  = ia*2-1
        nq  = ib*2-1
        npp = ic*2-1
        npm = id*2-1
c-----------------------------------------------------------------
c                   4-momentum of each particles
c-----------------------------------------------------------------
c
c  in the CENTER of MOMENTUM frame
c
        sh   = mi**2
        eq1  = (s+me2-sh)/(2.*rts)
        epp2 = .5*mi
c
        call momntx(eq1,me,costht,phi , q1)
        call momntx(epp2,me,cosalp,bet , pp2)
        call pmirrx(pp2 , pm2)
        call pmirrx(q1 , ppm)
        ppm(0) = rts-eq1
        call boostx(pp2,ppm , pp1)
        call boostx(pm2,ppm , pm1)
c
c  in the LABORATORY frame
c
        call psumxx(k0,p0 , kPp)
        call boostx(q1,kPp , q0)
        call boostx(pp1,kPp , pp0)
        call boostx(pm1,kPp , pm0)
        pr    = vabs(q0)
        tht   = acos( q0(3)/pr )
	thtp  = acos( pp0(3)/vabs(pp0) )
	thtm  = acos( pm0(3)/vabs(pm0) )
	opnang= acos( inprod(pp0,pm0)/(vabs(pp0)*vabs(pm0))  )
        cosalp1 = pm1(3)/vabs(pm1)
c-----------------------------------------------------------------
c             Experimental and Theoretical Cut Off
c-----------------------------------------------------------------
c
        if(costht.gt.cosalp1) then
           cross=0.D0
           return
        endif
c
c  Threshold for Recoil Momentum
c
	if(pr.lt.qmin)then
	   cross=0.D0
	   return
	endif
c
c  Angular spread of the Pair Counter
c
	if(thtp.gt.paircut.or.thtm.gt.paircut)then
	   cross=0.D0
	   return
	endif
c
c  Polar Angular Width of Recoil Counter
c
c	if(tht.lt.polmin.or.tht.gt.polmax)then
c	   cross=0.D0
c	   return
c	endif
c
c  Pair Opening Angle
c
c	if(opnang.lt.opnmin.or.opnang.gt.opnmax)then
c	   cross=0.D0
c	   return
c	endif
c----------------------------------
c            Event Dump
c----------------------------------
	if(IT.eq.ITMX2.and.idumpflag.eq.1)then
c          write(33)k0
c          write(33)p0
           write(33)ielec,real(q0(1)),real(q0(2)),real(q0(3))
           write(33)iposi,real(pp0(1)),real(pp0(2)),real(pp0(3))
           write(33)ielec,real(pm0(1)),real(pm0(2)),real(pm0(3))
           ievent = ievent + 1
           if(ievent.ge.ievmax)then idumpflag=0
	endif
c----------------------------------------------------------------
c                  Differentioal Cross Section
c-----------------------------------------------------------------
c
        call tppamp(k1,p1,q1,pp1,pm1,nk,np,nq,npp,npm , amp)
c
        msqr  = dble(conjg(amp)*amp)/2.D0
	polfac= .5*(1.+nk*pol/100.)
        jcob1 = fac2*exx/((1.0+exx)**2)
        jcob3 = lnmir*mi
        cnorm = vabs(q1)*vabs(pp2)
c
c	cross = polfac * fac * cnorm * msqr
        cross = polfac * fac * cnorm * msqr * jcob1 * jcob3
c
	call xhfill( 1,  opnang, cross)
c        call xhfill( 1,    pr  , cross)
c        call xhfill( 2,   tht  , cross)
c        call xhfill( 3,   phi  , cross)
c        call xhfill( 4,    mi  , cross)
c        call xhfill( 5,  pp0(0), cross)
c	call hfill(100,phi,0.,cross*wgt)
c
        return
        end
