C******************************************************
      SUBROUTINE COUPL2(SW2 , GAL)
C******************************************************
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 GAL(2)
C
C      ALPHA  = 1./128.
      ALPHA  = 1./DBLE(137.0359895)
      FOURPI = DBLE(4.*3.14159265358979323846)
      E =DSQRT(ALPHA *FOURPI)
      SW=DSQRT(SW2)
      CW=DSQRT(1.-SW2)
      EZ=E/(SW*CW)
C
      GAL(1)=-E
      GAL(2)=-E
      RETURN
      END
C
C******************************************************
      SUBROUTINE V0POLX(POL , VECT)
C******************************************************
C
C This subroutine computes the MASSLESS VECTOR wavefunction.
C
C INPUT:
C       real    POL       : polarization of MASSLESS VECTER
C OUTPUT:
C       complex VECT(0:3) : wavefunction of the vector particle
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 VECT(0:3)
C
      VECT(0)=(0. , 0.)
      VECT(1)=DCMPLX(DSQRT(POL/100.))
      VECT(2)=DCMPLX(DSQRT(1.-POL/100.))
      VECT(3)=(0. , 0.)
      RETURN
      END
C
C******************************************************
      SUBROUTINE V0LINX(NPOL , VECT)
C******************************************************
C
C This subroutine computes the MASSLESS VECTOR wavefunction.
C
C INPUT:
C       real    NPOL       : polarization of MASSLESS VECTER
C		-1         : 100% y-polarized photon
C		 1	   : 100% x-polarized photon
C OUTPUT:
C       complex VECT(0:3) : wavefunction of the vector particle
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 VECT(0:3)
C
      VECT(0)=(0. , 0.)
      VECT(1)=DCMPLX(.5*(1+NPOL))
      VECT(2)=DCMPLX(.5*(1-NPOL))
      VECT(3)=(0. , 0.)
      RETURN
      END
C
C************************************************
	function vabs(v)
C************************************************
	real*8 vabs,v(0:3)
	vabs=dsqrt(v(1)**2+v(2)**2+v(3)**2)
	return
	end
c
c***********************************
	function inprod(a,b)
c***********************************
	real*8 inprod,a(0:3),b(0:3)
	inprod = a(1)*b(1) + a(2)*b(2) + a(3)*b(3)
	return
	end
